Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 678224 - sys-kernel/gentoo-sources-4.20.10 with LD=gold: /usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:143: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
Summary: sys-kernel/gentoo-sources-4.20.10 with LD=gold: /usr/src/linux-4.20.10-gentoo...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo Kernel Bug Wranglers and Kernel Maintainers
URL: https://bugzilla.kernel.org/show_bug....
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2019-02-17 10:54 UTC by Dennis Schridde
Modified: 2019-02-24 08:39 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
config-4.20.10-gentoo (.config,199.66 KB, text/plain)
2019-02-17 10:54 UTC, Dennis Schridde
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Dennis Schridde 2019-02-17 10:54:53 UTC
Created attachment 565628 [details]
config-4.20.10-gentoo

VDSO    arch/x86/entry/vdso/vdso64.so.dbg                                                                             
  VDSO    arch/x86/entry/vdso/vdsox32.so.dbg                                                                                                                                                                                                                                                                                                                                
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:143: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:150: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:152: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'                                                                                                                                                                                                                                 
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:156: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:157: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:169: error: relocation overflow: reference to 'hvclock_page'
/usr/src/linux-4.20.10-gentoo/include/linux/compiler.h:191: error: relocation overflow: reference to 'hvclock_page'
/usr/src/linux-4.20.10-gentoo/include/linux/compiler.h:191: error: relocation overflow: reference to 'hvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/processor.h:660: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/processor.h:660: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/pvclock.h:85: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/pvclock.h:84: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/pvclock.h:73: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/include/asm/pvclock.h:87: error: relocation overflow: reference to 'pvclock_page'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:203: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:217: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/vclock_gettime.c:218: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
/usr/src/linux-4.20.10-gentoo/include/linux/compiler.h:191: error: relocation overflow: reference to 'vvar_vsyscall_gtod_data'
  VDSO    arch/x86/entry/vdso/vdso32.so.dbg
  OBJCOPY arch/x86/entry/vdso/vdso64.so
  OBJCOPY arch/x86/entry/vdso/vdsox32.so
objcopy: 'arch/x86/entry/vdso/vdsox32.so.dbg': No such file
make[5]: *** [/usr/src/linux-4.20.10-gentoo/arch/x86/entry/vdso/Makefile:120: arch/x86/entry/vdso/vdsox32.so] Error 1
make[4]: *** [/usr/src/linux-4.20.10-gentoo/scripts/Makefile.build:516: arch/x86/entry/vdso] Error 2
make[3]: *** [/usr/src/linux-4.20.10-gentoo/scripts/Makefile.build:516: arch/x86/entry] Error 2
make[3]: *** Waiting for unfinished jobs....


Portage 2.3.60 (python 2.7.13-final-42, default/linux/amd64/17.1/desktop/plasma/systemd, gcc-8.2.0, glibc-2.28-r5, 4.20.7-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.20.7-gentoo-x86_64-AMD_Ryzen_5_2400G_with_Radeon_Vega_Graphics-with-gentoo-2.6
KiB Mem:    15190988 total,    192764 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Sun, 17 Feb 2019 09:15:01 +0000
Head commit of repository gentoo: 62f712e79805c9d040c9bf278b64c5a892d81d92
Head commit of repository flatpak-overlay: 1fb00e4498c7e6951b50197eb23686e7b8f57024

Timestamp of repository gnome: Sat, 16 Feb 2019 23:23:38 +0000
Head commit of repository gnome: 99411d490dcfdee7e46f487bb47cd3c279ce6255

Head commit of repository local: 0bac0b7ad9c4f1bf38ee65a266a8b48e7843971e

sh bash 5.0_p2
ld GNU gold (Gentoo 2.31.1 p5 2.31.1) 1.16
ccache version 3.6 [disabled]
app-shells/bash:          5.0_p2::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.28.0::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.6::gentoo, 3.7.0::gentoo
dev-util/ccache:          3.6::gentoo
dev-util/cmake:           3.13.4::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/sandbox:         2.15::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.31.1-r4::gentoo
sys-devel/gcc:            8.2.0-r6::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r5::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.20::gentoo (virtual/os-headers)
sys-libs/glibc:           2.28-r5::gentoo
Repositories:

gentoo
    location: /var/cache/portage/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.de.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-extra-opts: 
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-metamanifest: yes

flatpak-overlay
    location: /var/db/repos/flatpak-overlay
    sync-type: git
    sync-uri: https://github.com/fosero/flatpak-overlay.git
    masters: gentoo

gnome
    location: /var/db/repos/gnome
    sync-type: git
    sync-uri: https://github.com/gentoo-mirror/gnome.git
    masters: gentoo

local
    location: /var/cache/portage/local
    sync-type: git
    sync-uri: https://github.com/devurandom/gentoo-overlay.git
    masters: gentoo gnome
    priority: 1000

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-pipe -O2 -march=znver1"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /etc/grs/systems.conf /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.6/conf"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php7.3/ext-active/ /etc/php/cgi-php7.3/ext-active/ /etc/php/cli-php7.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-pipe -O2 -march=znver1"
DISTDIR="/var/cache/portage/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going --nospinner --verbose-conflicts"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildsyspkg cgroup compressdebug config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch parallel-install pid-sandbox preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_GB.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu"
MAKEOPTS="-j6 -l4"
PKGDIR="/var/cache/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/tmp"
USE="7z 7zip X a52 aac aacplus aacs acl acpi activities aio alsa amd64 appindicator appstream archive audit avahi ayatana bash-completion bdplus berkdb bluetooth bluray branding brotli bs2b btrfs bzip2 cairo caps cdda cddb cdio cdr celt chromaprint cjk clang cli clipboard colord colorio conntrack crypt cups cxx d3d9 dbus declarative device-mapper dirac djvu dri drm dts dvb dvd dvdr editorconfig egl elf emboss encode epub exif fam fax fbcon ffmpeg fftw filecaps firefox firewalld fish-completion fits flac fontconfig fontforge fortran fribidi gbm gdbm geoclue geolocation gif git glamor gles gmp google googledrive gpg gps graphicsmagick gstreamer gtk gtk3 gzip harfbuzz hdf5 heif http2 ibus iconv icu idn imlib inotify introspection ipv6 jemalloc jpeg jpeg2k json kde kipi kms kwallet ladspa latex lcms ldap libatomic libidn2 libinput libnotify libproxy libsecret libsoxr libtirpc libvirt lm_sensors lrz lv2 lvm lz4 lzma lzo mad markdown mbim mercurial mjpeg mng mobi modemmanager modplug mp3 mp4 mpeg mplayer mpris mtp multilib mysql ncurses netlink networkmanager nls nptl office ofx ogg openal opencl opencv openexr opengl openh264 openmax openmp opus pam pango pcap pch pcre pcre2 pdf pgo phonon pixman plasma png policykit postscript ppds prison pulseaudio python qml qt5 rar raw readline redfish samba sasl scanner schroedinger sctp sdl sdl2 seccomp semantic-desktop share snappy sparse speech speex spell ssl startup-notification steamruntime stemmer svg systemd systemtap tbb tcpd teamd telepathy tga theora threads tiff timezone truetype tslib udev udisks unicode unwind upnp upnp-av upower usb utempter v4l v4l2 vaapi vdpau vkd3d vorbis vpx vulkan wasm wavpack wayland webchannel webengine webkit webp widgets wmf wps x264 x265 xattr xcb xcomposite xinerama xkb xml xmp xrandr xscreensaver xv xvid xwayland xz yaml zeroconf zeromq zlib zstd" ABI_X86="64" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext pclmul popcnt sse sse2 sse3 sse4_1 sse4_2 sse4a ssse3" ELIBC="glibc" ENLIGHTENMENT_MODULES="*" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="efi-64" INPUT_DEVICES="joystick libinput" KERNEL="linux" L10N="de de-DE en en-GB ar fa tr ja ko zh zh-CN zh-TW" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LIRC_DEVICES="devinput" LLVM_TARGETS="AMDGPU BPF" LUA_TARGET="lua5-2" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-1" POSTGRES_TARGETS="postgres9_5 postgres10" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6 pypy pypy3" QEMU_SOFTMMU_TARGETS="riscv32 riscv64 x86_64" QEMU_USER_TARGETS="riscv32 riscv64" RUBY_TARGETS="ruby24" STEAMGAMES="dirt_rally dont_starve portal source_engine te120 trine2 witcher2" USERLAND="GNU" VIDEO_CARDS="amdgpu virgl" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

sys-kernel/gentoo-sources-4.20.6::gentoo was built with the following:
USE="-build -experimental -symlink" ABI_X86="(64)"


sys-kernel/gentoo-sources-4.20.7::gentoo was built with the following:
USE="-build -experimental -symlink" ABI_X86="(64)"


sys-kernel/gentoo-sources-4.20.8::gentoo was built with the following:
USE="-build -experimental -symlink" ABI_X86="(64)"


sys-kernel/gentoo-sources-4.20.10::gentoo was built with the following:
USE="-build -experimental -symlink" ABI_X86="(64)"
Comment 1 Thomas Deutschmann gentoo-dev Security 2019-02-17 14:48:39 UTC
This is known. Don't use GOLD linker until this is fixed.
Comment 2 Dennis Schridde 2019-02-17 18:34:44 UTC
(In reply to Thomas Deutschmann from comment #1)
> This is known. Don't use GOLD linker until this is fixed.

In that case this is triggered by USE=default-gold on sys-devel/binutils-2.31.1-r4.
Comment 3 Dennis Schridde 2019-02-17 18:38:13 UTC
(In reply to Dennis Schridde from comment #2)
> (In reply to Thomas Deutschmann from comment #1)
> > This is known. Don't use GOLD linker until this is fixed.
> 
> In that case this is triggered by USE=default-gold on
> sys-devel/binutils-2.31.1-r4.

Workaround is `make LD=ld.bfd` when building the kernel.
Comment 4 Red 2019-02-24 08:36:30 UTC
(In reply to Dennis Schridde from comment #3)
> (In reply to Dennis Schridde from comment #2)
> > (In reply to Thomas Deutschmann from comment #1)
> > > This is known. Don't use GOLD linker until this is fixed.
> > 
> > In that case this is triggered by USE=default-gold on
> > sys-devel/binutils-2.31.1-r4.
> 
> Workaround is `make LD=ld.bfd` when building the kernel.

This does not work for me, I have to switch to ld.bfd using binutils-config whenever I want to build the kernel, and then put it back to gold when I'm finished.

I can link the proprietary NVIDIA module (from x11-drivers/nvidia-drivers) with ld.gold, no problems.
Comment 5 Red 2019-02-24 08:39:28 UTC
(In reply to Red from comment #4)
> (In reply to Dennis Schridde from comment #3)
> > (In reply to Dennis Schridde from comment #2)
> > > (In reply to Thomas Deutschmann from comment #1)
> > > > This is known. Don't use GOLD linker until this is fixed.
> > > 
> > > In that case this is triggered by USE=default-gold on
> > > sys-devel/binutils-2.31.1-r4.
> > 
> > Workaround is `make LD=ld.bfd` when building the kernel.
> 
> This does not work for me, I have to switch to ld.bfd using binutils-config
> whenever I want to build the kernel, and then put it back to gold when I'm
> finished.
> 
> I can link the proprietary NVIDIA module (from x11-drivers/nvidia-drivers)
> with ld.gold, no problems.

EDIT: I'm currently using gentoo-sources 4.19.23, not 4.20.10.